Class: Chef::Provider::Package::Chocolatey

Inherits:
Chef::Provider::Package show all
Includes:
Mixin::PowershellOut
Defined in:
lib/chef/provider/package/chocolatey.rb

Constant Summary collapse

PATHFINDING_POWERSHELL_COMMAND =
"[System.Environment]::GetEnvironmentVariable('ChocolateyInstall', 'MACHINE')".freeze
CHOCO_MISSING_MSG =
<<-EOS.freeze
Could not locate your Chocolatey install. To install chocolatey, we recommend
the 'chocolatey' cookbook (https://github.com/chocolatey/chocolatey-cookbook).
If Chocolatey is installed, ensure that the 'ChocolateyInstall' environment
variable is correctly set. You can verify this with the PowerShell command
'#{PATHFINDING_POWERSHELL_COMMAND}'.
EOS

Instance Attribute Summary

Attributes inherited from Chef::Provider

#action, #cookbook_name, #current_resource, #new_resource, #recipe_name, #run_context

Instance Method Summary collapse

Methods included from Mixin::PowershellOut

#powershell_out, #powershell_out!

Methods included from Mixin::WindowsArchitectureHelper

#assert_valid_windows_architecture!, #disable_wow64_file_redirection, #forced_32bit_override_required?, #is_i386_process_on_x86_64_windows?, #node_supports_windows_architecture?, #node_windows_architecture, #restore_wow64_file_redirection, #valid_windows_architecture?, #with_os_architecture, #wow64_architecture_override_required?, #wow64_directory

Methods included from Mixin::ShellOut

#a_to_s, #clean_array, #shell_out, #shell_out!, #shell_out_compact, #shell_out_compact!, #shell_out_compact_timeout, #shell_out_compact_timeout!, #shell_out_with_systems_locale, #shell_out_with_systems_locale!

Methods included from Mixin::PathSanity

#enforce_path_sanity, #sanitized_path

Methods inherited from Chef::Provider::Package

#action_lock, #action_unlock, #as_array, #expand_options, #get_preseed_file, #have_any_matching_version?, #initialize, #lock_package, #multipackage_api_adapter, #options, #package_locked, #preseed_package, #preseed_resource, #reconfig_package, #removing_package?, #target_version_already_installed?, #unlock_package, #version_requirement_satisfied?

Methods included from Mixin::SubclassDirective

#subclass_directive

Methods inherited from Chef::Provider

action, #action_nothing, #cleanup_after_converge, #compile_and_converge_action, #converge_by, #converge_if_changed, #events, include_resource_dsl?, include_resource_dsl_module, #initialize, #node, #process_resource_requirements, provides, provides?, #requirements, #resource_collection, #resource_updated?, #run_action, #set_updated_status, supports?, use_inline_resources, #whyrun_mode?, #whyrun_supported?

Methods included from Mixin::Provides

#provided_as, #provides, #provides?

Methods included from Mixin::DescendantsTracker

#descendants, descendants, #direct_descendants, direct_descendants, #find_descendants_by_name, find_descendants_by_name, #inherited, store_inherited

Methods included from Mixin::LazyModuleInclude

#descendants, #include, #included

Methods included from Mixin::NotifyingBlock

#notifying_block, #subcontext_block

Methods included from DSL::DeclareResource

#build_resource, #declare_resource, #delete_resource, #delete_resource!, #edit_resource, #edit_resource!, #find_resource, #find_resource!, #with_run_context

Methods included from DSL::PlatformIntrospection

#docker?, #platform?, #platform_family?, #value_for_platform, #value_for_platform_family

Constructor Details

This class inherits a constructor from Chef::Provider::Package

Instance Method Details

#action_uninstallObject

Support :uninstall as an action in order for users to easily convert from the chocolatey provider in the cookbook. It is, however, already deprecated.


130
131
132
133
# File 'lib/chef/provider/package/chocolatey.rb', line 130

def action_uninstall
  Chef::Log.deprecation "The use of action :uninstall on the chocolatey_package provider is deprecated, please use :remove"
  action_remove
end

#candidate_versionArray

Lazy initializer for candidate_version. A nil value means that there is no candidate version and the package is not installable (generally an error).

Returns:

  • (Array)

    list of candidate_versions indexed same as new_resource.package_name/version


71
72
73
# File 'lib/chef/provider/package/chocolatey.rb', line 71

def candidate_version
  @candidate_version ||= build_candidate_versions
end

#check_resource_semantics!Object

Override the superclass check. The semantics for our new_resource.source is not files to install from, but like the rubygem provider's sources which are more like repos.


140
# File 'lib/chef/provider/package/chocolatey.rb', line 140

def check_resource_semantics!; end

#define_resource_requirementsObject


52
53
54
55
56
57
58
59
60
61
62
63
64
65
# File 'lib/chef/provider/package/chocolatey.rb', line 52

def define_resource_requirements
  super

  # The check that Chocolatey is installed is in #choco_exe.

  # Chocolatey source attribute points to an alternate feed
  # and not a package specific alternate source like other providers
  # so we want to assert candidates exist for the alternate source
  requirements.assert(:upgrade, :install) do |a|
    a.assertion { candidates_exist_for_all_uninstalled? }
    a.failure_message(Chef::Exceptions::Package, "No candidate version available for #{packages_missing_candidates.join(', ')}")
    a.whyrun("Assuming a repository that offers #{packages_missing_candidates.join(', ')} would have been configured")
  end
end

#install_package(names, versions) ⇒ Object

Install multiple packages via choco.exe

Parameters:

  • names (Array<String>)

    array of package names to install

  • versions (Array<String>)

    array of versions to install


79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
# File 'lib/chef/provider/package/chocolatey.rb', line 79

def install_package(names, versions)
  name_versions_to_install = desired_name_versions.select { |n, v| lowercase_names(names).include?(n) }

  name_nil_versions = name_versions_to_install.select { |n, v| v.nil? }
  name_has_versions = name_versions_to_install.reject { |n, v| v.nil? }

  # choco does not support installing multiple packages with version pins
  name_has_versions.each do |name, version|
    choco_command("install -y --version", version, cmd_args, name)
  end

  # but we can do all the ones without version pins at once
  unless name_nil_versions.empty?
    cmd_names = name_nil_versions.keys
    choco_command("install -y", cmd_args, *cmd_names)
  end
end

#load_current_resourceChef::Resource::ChocolateyPackage

Responsible for building the current_resource.

Returns:


45
46
47
48
49
50
# File 'lib/chef/provider/package/chocolatey.rb', line 45

def load_current_resource
  @current_resource = Chef::Resource::ChocolateyPackage.new(new_resource.name)
  current_resource.package_name(new_resource.package_name)
  current_resource.version(build_current_versions)
  current_resource
end

#remove_package(names, versions) ⇒ Object Also known as: purge_package

Remove multiple packages via choco.exe

Parameters:

  • names (Array<String>)

    array of package names to install

  • versions (Array<String>)

    array of versions to install


123
124
125
# File 'lib/chef/provider/package/chocolatey.rb', line 123

def remove_package(names, versions)
  choco_command("uninstall -y", cmd_args(include_source: false), *names)
end

#upgrade_package(names, versions) ⇒ Object

Upgrade multiple packages via choco.exe

Parameters:

  • names (Array<String>)

    array of package names to install

  • versions (Array<String>)

    array of versions to install


101
102
103
104
105
106
107
108
109
110
111
112
113
114
115
116
117
# File 'lib/chef/provider/package/chocolatey.rb', line 101

def upgrade_package(names, versions)
  name_versions_to_install = desired_name_versions.select { |n, v| lowercase_names(names).include?(n) }

  name_nil_versions = name_versions_to_install.select { |n, v| v.nil? }
  name_has_versions = name_versions_to_install.reject { |n, v| v.nil? }

  # choco does not support installing multiple packages with version pins
  name_has_versions.each do |name, version|
    choco_command("upgrade -y --version", version, cmd_args, name)
  end

  # but we can do all the ones without version pins at once
  unless name_nil_versions.empty?
    cmd_names = name_nil_versions.keys
    choco_command("upgrade -y", cmd_args, *cmd_names)
  end
end